<template>
  <div id="activity-create-modal">
    <div class="modal">
      <div class="modal-header">
        <label>Tạo hoạt động</label>
      </div>  
      <div class="modal-body">
        <div class="section">
          <label>Tên hoạt động</label>
          <div class="textfield" style="margin-top: 10px">
            <input v-model="activity.name" type="text" placeholder=" " class="textinput"/>
          </div>
        </div>
        <div class="section">
          <label>Ảnh bìa hoạt động</label>
          <div v-if="activity.img_url!=''" class="cover-image">
            <img :src="activity.img_url">
          </div>
          <div v-else class="cover-image">
            <p style="margin:10px; font-style:italic">Hãy tải lên ảnh của bạn</p>
          </div>
          <input type="file" style="display:none" ref="imgInput" accept="image/*" @change="onImgPicked"/>
          <button class="upload-image-button" @click="pickImg">Chọn ảnh</button>
        </div>
        <div class="section">
          <label>Mô Tả Hoạt động</label>
          <div class="editor">
            <QuillEditor v-model:content="activity.description" contentType="html" theme="snow" />
          </div>
        </div>
      </div>  
      <div class="modal-footer">
        <button class="cancel-btn" @click="closeModal">Đóng</button>
        <button v-if="!creating" class="create-btn" @click="createActivity">Tạo mới</button>
        <button v-else class="create-btn disable">Tạo mới</button>
      </div>
    </div>
  </div>
</template>

<script>
import { QuillEditor } from '@vueup/vue-quill'
import '@vueup/vue-quill/dist/vue-quill.snow.css';
import DonationService from '@/services/DonationService';

export default {
  name: 'ActivityCreateModal',
  components: {
    QuillEditor
  },
  data(){
    return {
      creating: false,
      activity: {
        name: '',
        img_url: '',
        description: ''
      },
      coverImg: null
    }
  },
  methods: {
    pickImg(){
      this.$refs.imgInput.click()
    },
    async onImgPicked(event){
      const file = event.target.files[0]
      this.coverImg = file
      this.activity.img_url = URL.createObjectURL(this.coverImg)
    },
    closeModal(){
      this.name = ""
      this.$emit('close')
    },
    async createActivity(){
      if(this.activity.name == '' || this.activity.description == '') {
        alert('Enter some field please')
        return;
      }

      if (this.creating) return
      this.creating = true

      try{
        let response = await DonationService.createDonation({
          name: this.activity.name,
          description: this.activity.description,
          createDate: Date.now(),
          enabled: true
        })
        console.log(response)
        if(response.status == 200){
          alert("Activity create successfully")
          this.$emit('create')
        }
        else{          
          alert(response.statusText)
        }        
      }
      catch(err){        
        console.log(err)
        alert('Something when wrong')
      }
      finally{
        console.log('createDonation')
        this.creating = false
      }
    }
  }
}
</script>

<style scoped>
#activity-create-modal{
  position: fixed;
  top: 0;
  bottom: 0;
  right: 0;
  left: 0;
  z-index: 99;
  background-color: rgb(0, 0, 0, 0.4);
  display: flex;
  justify-content: center;
  align-items: center;
}

.modal {
  width: 800px;
  background-color: #FFF;
  border-radius: 10px; 
  padding: 20px;
  display: flex;
  flex-direction: column;
}

.modal > div{
  width: 100%;
  display: flex;
}

.modal-header{  
  margin-bottom: 10px;
}
.modal-header > label {
  font-weight: bold;
}

.modal-body{
  margin: 10px 0px;
  flex-direction: column;
  font-size: 16px;
}

.section{
  margin-bottom: 20px;
  display: flex;
  flex-direction: column;
}

.section p{
  margin: 0;
  padding: 0;
  font-size: 13px;
}

.cover-image{  
  width: 100%;
  max-height: 160px;
  margin: 10px 0px;  
  border-radius: 4px;
  border: 1px solid #cecece;
  background-color: #ddd;
  align-items: center;
}
.cover-image img{
  zoom: 2;
  width: 100%;
  height: 100%;
  object-fit: contain;
}
.upload-image-button{
  width: fit-content;
  border: 0;
  padding: 0;
  background: transparent;
  font-size: 14px;
  color: blue
}

.upload-image-button:hover {
  cursor: pointer;
}

.textfield{
  position: relative;
  width: 100%;
  max-width: 800px;
}

.textinput{
  padding: 10px;
  outline: 0;
  border-radius: 4px;
  border: 1px solid #cecece;
  z-index: 1;
  font-size: 16px;
  width: calc(100% - 20px);
}
.textnput:focus {  
  border: 1px solid blue;
}

.editor{
  margin-top: 10px;
  height: 160px;
  overflow-y: auto;
}

.modal-footer{
  justify-content: flex-end;
}

.modal-footer button{
  margin-left: 10px;
  border: 1px solid blue;
  padding: 8px;
  border-radius: 5px;
}

.create-btn{
  background-color: #22f;  
  color: white;
}
.cancel-btn{
  background-color: white;  
  color: blue;
}

.disable{  
  background-color: #66f;  
  color: white;
}

.modal-footer button:hover{
  cursor: pointer;
}
</style>
